package molmaster;

/** Defines attributes for a set of atoms.
 *
 * @author  rjpower
 */
public class AtomAttributes extends MolAttributes{
    
    /** If the distance between this atom and another
     *  is less then the sum of their bond radiaii, then running the
     *  auto bonding function will insert a bond between
     *  the two.*/
    public double bondingRadius;
    
    /** The atomic number of this atom.  This is used when
     *  adding an atom for the first time - a lookup is 
     *  performed from the attribute table to find the correct
     *  attribute for the new atom based on it's number.
     */
    public int atomicNumber;
    
    /** The descriptive name of this atom( helium-4... )    */
    public String atomName;
    
    /** The atomic symbol of this atom. */
    public String atomicSymbol;
    
    /** The mass of this atom */
    public double atomicMass;
    
    public double vanDerWaal;
    /** Creates a new instance of AtomAttributes */
    public AtomAttributes() {
        atomicSymbol = "";
        atomName = "";
        vanDerWaal = 1.0;
        bondingRadius = 1.0;
        radius = 0.5;
    }
    
    public AtomAttributes( AtomAttributes copy ) {
        vanDerWaal = copy.vanDerWaal;
        atomicSymbol = copy.atomicSymbol;
        atomName = copy.atomName;
        atomicNumber = copy.atomicNumber;
        bondingRadius = copy.bondingRadius;
    }
    
}
