package molmaster.gui;

import molmaster.*;
import java.awt.*;
import java.util.*;
import java.awt.image.*;

/** Provides convenience methods for loading images from disk.  This
 *  class also keeps track of images currently in memory and ensures
 *  that multiple requests for the same image base return a single 
 *  image.
 *
 * @author  Russell Power
 */
public class ImageCache {
    
    static protected Map imageMap = new HashMap();
    static protected int maxSize = 20;
    static protected Component observer = new javax.swing.JPanel();
    
    /** Returns an image corresponding to the given file.
     */    
    static public BufferedImage getImage( String source ) {
            
        Object test = imageMap.get(source);
        
        if ( test != null ) {
            Log.info( "Hit in image cache." );
            return (BufferedImage)test;
        }
        java.net.URL u = imageMap.getClass().getResource( "/graphics/" + source );
        Image i = new javax.swing.ImageIcon( u ).getImage();

        int w = i.getWidth(observer);
        int h = i.getHeight(observer);
        
        if ( w <= 0 || h <= 0 ) { 
            Log.writeLog( "Couldn't read image..." );
        }
        BufferedImage b = new BufferedImage( w, h, BufferedImage.TYPE_INT_ARGB );
        b.getGraphics().drawImage( i, 0, 0, observer );
        
        imageMap.put( source, b );
        return b;
    }
    
}
