package molmaster.gui;

import javax.media.j3d.*;
/** Defines the interface that must be supported
 *  by the views.  This interface is used by the 
 *  input handlers to show graphically changes in
 *  the environment.
 *
 * @author  Russell
 */
public interface MolView {
    
    public static final int VIEW_BALL_STICK = 0x0001;
    public static final int VIEW_SPACE_FILL = 0x0002;
    public static final int VIEW_BARE_LINE  = 0x0004;
    
    public static final int RESOLUTION_LOW  = 0x0001;
    public static final int RESOLUTION_HIGH = 0x0002;
    
    public static final javax.media.j3d.Geometry nullGeometry = new QuadArray( 1, GeometryArray.COORDINATES );
    
    
    /** Change this object so it appears to
     *  be selected.    */
    public void select();
    
    /** Change this object so it appears to be
     *  unselected. */
    public void unselect();
    
    /** Change the rendering of this object to
     *  the type specified, if possible.    */
    public void setViewType( int viewType );
    
    public boolean isVisible();
    public void setVisible( boolean vis );
    
    /** Sets the size of this object to the given value.  For atoms
     *  this results in an increase of the radius to the given value,
     *  for bonds, the cylinder radius is increased to the given value.
     */
    public void setSize(double size);
    public double getSize();
    
    /** Returns the object that this view is representing.  */
    public molmaster.MolObject getModelObject();

    /** Returns the transformation group holding this 
     *  object.*/
    public javax.media.j3d.Group getOwner();
    
    public void setDefaultAppearance(javax.media.j3d.Appearance a);
    
    public void removeFromScene();
}

