/*
 * ActiveAction.java
 *
 * Created on May 24, 2002, 9:46 PM
 */

package molmaster.gui.editbar;

import molmaster.*;

/** Provides an access point for the edit handler
 *  currently in use.
 *
 * @author  Russell
 */
public class ActiveAction {
    
    static private EditAction currentAction = null;
    static boolean returningToDefault = false;
    
    /** Notify the currently active handler of the 
     *  given event.
     */
    static public void notifyHandler( Object source, molmaster.Event evt ) {
        if ( currentAction != null )
            currentAction.actionPerformed( source, evt );
    }
    
    /** Sets the currently active handler to the given
     *  EditAction object.  When events occur which affect
     *  the EditBar, the active handler receives and 
     *  processes them.
     */
    static public void setHandler( EditAction a ) {
        if ( currentAction != null ) 
        currentAction.actionPerformed( null, new Event( EditAction.handlerDeactivate ) );
        currentAction = a; 
        currentAction.actionPerformed( null, new Event(EditAction.handlerActivate) );
        returningToDefault = false;
    }
    
    /** Changes the current handler to the default. */
    static public void setDefaultHandler() {
        if ( returningToDefault ) { return; }
        returningToDefault = true;
        EditBar e = EditBar.getBar();
        
        e.defaultButton.setSelected( true );
        setHandler(e.defaultHandler);
    }
    
}
