/*
 * BondDistance.java
 *
 * Created on May 25, 2002, 12:40 PM
 */

package molmaster.gui.editbar;

import molmaster.*;
import molmaster.gui.*;

import javax.vecmath.*;
/**
 *
 * @author  Russell
 */
public class BondDistance extends DefaultAction {
    
    AtomView next;
    /** Creates a new instance of BondDistance */
    public BondDistance() {
    }
    
    public String getHandlerGroup() { return "Selection"; }
    public String getHandlerName() { return "Bond Distance"; }
    
    
    public void actionPerformed( Object source, molmaster.Event e ) {
        if ( e.getID().equals( handlerActivate ) ){
            MainFrame.setStatusMessage( "Select first atom." );
        }
        
        if ( e.getID().equals( molmaster.gui.input.MouseSelect.mouseSelect ) ) {
            Object o = e.getData();
            
            if ( o instanceof AtomView ) {
                if ( selected.size() == 0 || selected.size() == 2) { 
                    clearSelected();
                    MainFrame.setStatusMessage( "Select second atom." );
                    selected.add( o );
                    ((AtomView)o).select();
                    return; 
                }
                
                next = (AtomView)o;
                next.select();
                selected.add( next );
                
                Atom a = ((AtomView)selected.get(0)).getAtom();
                Atom b = next.getAtom();
                
                Vector3d dist = new Vector3d();
                dist.sub( b.getLocation(), a.getLocation() );
                
                Vector3f sh = new Vector3f();
                sh.set( dist );
                
                String outText = "Total distance: " + sh.length() + "\n";
                outText += "(x: " + sh.x + ", y:" + sh.y + ", z:" + sh.z +")";
                
                MainFrame.setStatusMessage( outText );
            }
        }  
        super.actionPerformed( source, e );
    }
}
