package molmaster.gui.editbar;

import molmaster.*;

import java.util.*;

/**
 *
 * @author  Russell
 */
public abstract class DefaultAction implements EditAction  {
    
    static public List selected = new ArrayList();
    
    /** Creates a new instance of DefaultAction */
    public DefaultAction() {
    }
      
    static public void clearSelected() {
        Iterator i = molmaster.model.MolModel.getModel().getAtoms().iterator();
        while ( i.hasNext() ) {
            molmaster.gui.AtomView.atomToView( (Atom)i.next() ).unselect();
        }
        i = molmaster.model.MolModel.getModel().getBonds().iterator();
        while ( i.hasNext() ) {
            molmaster.gui.BondView.bondToView( i.next() ).unselect();
        }
        selected.clear();
    }
    
    /** Returns the handler group this belongs to - selection handlers might compose
     * one group, while angle calculations would belong to another.  The groups
     * will be clustered on the screen to indicate their relation.
     */
    public String getHandlerGroup() {
        return "Pointer";
    }
    
    public void actionPerformed( Object source, molmaster.Event evt ){
        if ( evt.getID().equals( EditAction.handlerActivate ) ) {
            clearSelected();
        }
    }
    
    /** Optional.  Return null if not implemented.  Returns a graphical icon to
     * display along with the text for this handler.    */
    public java.awt.Image getHandlerImage() { return null;}
    
    public String getHandlerName() { return "Pointer"; }
    public String getVersion() { return "0.1"; }
}
