package molmaster.gui.editbar;

import molmaster.*;
import molmaster.gui.*;
import molmaster.model.*;
import molmaster.model.loaders.*;

import java.util.*;

/** Constructs and displays isosurfaces derived from field
 *  values loaded into the current scene.
 *
 * @author  Russell Power
 */
public class IsoSurface extends DefaultAction {
    
    protected static IsoDialog id = new IsoDialog();
    
    public static IsoDialog getDialog() { return id; }
    
    /** Creates a new instance of Isosurface */
    public IsoSurface() {
    }
    
    /** Called when a significant update has occured.  Significant is
     * defined as 'whatever Russell felt like implementing', but in general
     * all expected events ( mouse clicks, drags, etc. ) will be reported.
     */
    public void actionPerformed(Object source, molmaster.Event evt) {
        //todo remove - testing...
        if ( evt.getID() == handlerActivate ) {
            Iterator i = MolModel.getModel().getFiles().iterator();
            while ( i.hasNext() ) {
                Object o = i.next();
                if ( o instanceof FieldFile ) {
                    id.setVisible( true );
                    Log.writeLog ( "Added surface to world." );
                    return;
                }
            }
            
            java.awt.Toolkit.getDefaultToolkit().beep();
            MainFrame.setStatusMessage( "No field data was found!" );
            ActiveAction.setDefaultHandler();
        }
    }
    
    /** Returns the handler group this belongs to - selection handlers might compose
     * one group, while angle calculations would belong to another.  The groups
     * will be clustered on the screen to indicate their relation.
     */
    public String getHandlerGroup() {
        return "Analysis";
    }
    
    /** Optional.  Return null if not implemented.  Returns a graphical icon to
     * display along with the text for this handler.    */
    public java.awt.Image getHandlerImage() {
        return null;
    }
    
    /** This is displayed to the user on the selection button for this handler.  */
    public String getHandlerName() {
        return "Isosurface Visualization";
    }
    
}
