package molmaster.gui.editbar;

import molmaster.*;
import molmaster.gui.*;
import molmaster.gui.input.*;
import javax.vecmath.*;
import java.util.*;
/**
 *
 * @author  rjpower
 */
public class RecenterRotation  extends DefaultAction {
    
    /** Creates a new instance of RecenterRotation */
    public RecenterRotation() {
    }
    
    /** Called when a significant update has occured.  Significant is
     * defined as 'whatever Russell felt like implementing', but in general
     * all expected events ( mouse clicks, drags, etc. ) will be reported.
     */
    public void actionPerformed(Object source, molmaster.Event evt) {
        if ( evt.getID() == handlerActivate ) {
            Point3d rotationPoint;
            if ( selected.size() > 0 ) {
                AtomView av = (AtomView)selected.get(0);
                Vector3d v = av.getAtom().getLocation();
                molmaster. Log.writeLog( v );
                rotationPoint = new Point3d( v );
            }
            else {
                //rotationPoint = new Point3d( 0,0,0 );
                rotationPoint = getCenter();
            }
            OrbitBehavior.getActive().setRotationCenter( rotationPoint );
            MainFrame.setStatusMessage( "Rotation recentered around point " + new Point3f(rotationPoint) );
            ActiveAction.setDefaultHandler();
        }
        
    }
    
    /** Returns the average location of all atoms in the scene. */    
    public Point3d getCenter() {
        Collection c = molmaster.model.MolModel.getModel().getAtoms();
        if ( c.size() == 0 ) { 
            return new Point3d( 0,0,0 );
        }
        double x = 0; double y = 0; double z = 0;
        Iterator i = c.iterator();
        while ( i.hasNext() ) {
            Vector3d v = (Vector3d)((Atom)i.next()).getLocation();
            x += v.x; y += v.y; z += v.z;
        }
        double s = c.size();
        return new Point3d( x / s, y / s, z / s );
    }
    /** Returns the handler group this belongs to - selection handlers might compose
     * one group, while angle calculations would belong to another.  The groups
     * will be clustered on the screen to indicate their relation.
     */
    public String getHandlerGroup() {
        return "Selection";
    }
    
    /** Optional.  Return null if not implemented.  Returns a graphical icon to
     * display along with the text for this handler.    */
    public java.awt.Image getHandlerImage() {
        return null;
    }
    
    /** This is displayed to the user on the selection button for this handler.  */
    public String getHandlerName() {
        return "Recenter Rotation";
    }
    
}
