package molmaster.gui.editbar.analysis;

import java.io.*;
import javax.swing.*;

/** Displays progress of an ongoing analysis session to the
 *  user.
 *
 * @author  Russell Power
 */
public class CDDialog extends javax.swing.JDialog {

	protected PrintStream oldOut;
	protected Thread analyze;
	/*
	protected String analysisType = "bader";
	
	class SelectDialog extends JDialog implements java.awt.event.ActionListener{
	    JList al = new JList();
	    SelectDialog() {
	        super( molmaster.gui.MainFrame.getActiveWindow(), true );
	        
	        DefaultListModel ml = new DefaultListModel();
	        ml.addElement( "bader" );
	        ml.addElement( "wigner seitz" );
	        al.setModel( ml );
	        al.setSelectionMode( ListSelectionModel.SINGLE_SELECTION );
	        al.setSelectedIndex( 0 );
	        getContentPane().add( new JLabel("Select analysis type:"), BorderLayout.NORTH );
	        getContentPane().add( al, BorderLayout.CENTER );
	        JButton b = new JButton("Okay");
	        b.addActionListener( this );
	        getContentPane().add( b, BorderLayout.SOUTH );
	        setSize( 200, 200);
	    }
	    
	    public void actionPerformed( java.awt.event.ActionEvent e ){
	        if ( al.getSelectedValue() != null ) {
	            analysisType = (String)al.getSelectedValue();
	        }
	        setVisible( false );
	        dispose();
	    }
	}*/

	/** Creates new form CNDialog */
	private CDDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		oldOut = System.out;
		setTitle("Charge Density Analysis");
	}

	private String currentText = "";
	public CDDialog(Thread t) {
		this(molmaster.gui.MainFrame.getActiveWindow(), true);
		//new SelectDialog().show();

		analyze = t;
		new File("calc.log").delete();
		new File("max_rho.dat").delete();

		t.start();
		
		btnOkay.setEnabled(false);
		btnCancel.setEnabled(true);

		Thread watcher = new Thread() {
			public void run() {

				File f = new File("calc.log");
				FileReader fr = null;
				BufferedReader br = null;
				logText.setText("Waiting for process output..." + "\n\n");
				do {
					try {
						Thread.sleep(50);
						fr = new FileReader(f);
						br = new BufferedReader(fr);
						String nl = null;
						String output = "";
						while ((nl = br.readLine()) != null) {
							output += nl + "\n";
						}
						if (currentText != output) {
							currentText = output;
							SwingUtilities.invokeAndWait(new Runnable() {
								public void run() {
									logText.setText( currentText );
									logText.invalidate();
								}
							});
						}
						fr.close();
					} catch (Exception e) {
					}
				}
				while (analyze.isAlive());
				btnOkay.setEnabled(true);
				btnCancel.setEnabled(false);
			}
			
		};
		
		try {
			watcher.start();
		} catch (Exception e) {
			molmaster.Log.writeLog("Couldn't redirect input - error was: ");
			molmaster.Log.writeLog(e);
		}

	}

	private void initComponents() { //GEN-BEGIN:initComponents
		logScroll = new javax.swing.JScrollPane();
		logText = new javax.swing.JTextArea();
		btnPanel = new javax.swing.JPanel();
		btnOkay = new javax.swing.JButton();
		btnCancel = new javax.swing.JButton();
		jLabel1 = new javax.swing.JLabel();

		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		logScroll.setDoubleBuffered(true);
		logText.setDoubleBuffered(true);
		logScroll.setViewportView(logText);

		getContentPane().add(logScroll, java.awt.BorderLayout.CENTER);

		btnPanel.setLayout(
			new javax.swing.BoxLayout(btnPanel, javax.swing.BoxLayout.Y_AXIS));

		btnOkay.setText("Okay");
		btnOkay.setEnabled(false);
		btnOkay.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btnOkayActionPerformed(evt);
			}
		});

		btnPanel.add(btnOkay);

		btnCancel.setText("Cancel");
		btnCancel.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btnCancelActionPerformed(evt);
			}
		});

		btnPanel.add(btnCancel);

		getContentPane().add(btnPanel, java.awt.BorderLayout.EAST);

		jLabel1.setText("Currently processing data file... please be patient");
		getContentPane().add(jLabel1, java.awt.BorderLayout.NORTH);

		setSize(new java.awt.Dimension(400, 271));
	} //GEN-END:initComponents

	private void btnOkayActionPerformed(
		java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_btnOkayActionPerformed
		setVisible(false);
		dispose();
	} //GEN-LAST:event_btnOkayActionPerformed

	private void btnCancelActionPerformed(java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_btnCancelActionPerformed
		/** This is in general a "bad thing" to do.  Since we are in the
		 *  middle of native code, however, and any reference to a flag
		 *  would have to be made in the middle of Fortran, this works.
		 */
		analyze.stop();
		setVisible(false);
		dispose();
	} //GEN-LAST:event_btnCancelActionPerformed

	/** Closes the dialog */
	private void closeDialog(
		java.awt.event.WindowEvent evt) { //GEN-FIRST:event_closeDialog
		setVisible(false);
		dispose();
	} //GEN-LAST:event_closeDialog

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JButton btnCancel;
	private javax.swing.JScrollPane logScroll;
	private javax.swing.JTextArea logText;
	private javax.swing.JButton btnOkay;
	private javax.swing.JPanel btnPanel;
	private javax.swing.JLabel jLabel1;
	// End of variables declaration//GEN-END:variables

}
