package molmaster.gui.editbar.analysis;

import molmaster.gui.editbar.*;

/** Implements CN( common neighbor ) analysis on 
 *  files currently loaded into molmaster.
 *
 *
 * @author  Russell Power
 */
public class CNAnalysis extends DefaultAction {
            
    private static CNDialog theDialog = null;
    
    /** Called when a significant update has occured.  Significant is
     *  defined as 'whatever Russell felt like implementing', but in general
     *  all expected events ( mouse clicks, drags, etc. ) will be reported.
     *
     */
    public void actionPerformed(Object source, molmaster.Event evt) {
        if ( evt.getID() == handlerActivate ){ 
            if ( theDialog == null ) {
                theDialog = new CNDialog();
            }
            theDialog.show();
        }
        super.actionPerformed( source, evt );
    }
    
    /** Returns the handler group this belongs to - selection handlers might compose
     *  one group, while angle calculations would belong to another.  The groups
     *  will be clustered on the screen to indicate their relation.
     *
     */
    public String getHandlerGroup() {
        return "Analysis";
    }
    
    /** Optional.  Return null if not implemented.  Returns a graphical icon to
     *  display along with the text for this handler.
     */
    public java.awt.Image getHandlerImage() {
        return null;
    }
    
    /** This is displayed to the user on the selection button for this handler.  */
    public String getHandlerName() {
        return "CN Analysis";
    }
    
}
