package molmaster.gui.editbar.analysis;

import molmaster.util.*;

/** Provides a class to encapsulate settings for 
 *  common neighbor analysis.
 *
 * @author  Russell Power
 */
public class RDSettings {
    double res = 0.05;
    double max = 10.0;
    double min = 0.0;
    float peakValue = 0.3f;
    
    private DataStore info = new DataStore("appSettings");
    
    public RDSettings() {
        Double d = (Double)info.get( "RDSettings.res" );
        if ( d != null ) { res = d.doubleValue(); }
        d = (Double)info.get( "RDSettings.max" );
        if ( d != null ) { max = d.doubleValue(); }
        d = (Double)info.get( "RDSettings.min" );
        if ( d != null ) { min = d.doubleValue(); }
        d = (Double)info.get( "RDSettings.peak" );
        if ( d != null ) { peakValue = d.floatValue(); }
    }
    public void setResolution( double res ) { 
        this.res = res; 
        info.put( "RDSettings.res", new Double( res ) );
        info.flush();
    }
    
    public double getResolution() { return res; }
    
    public void setMaximumSize( double s ) { 
        max = s; 
        info.put( "RDSettings.max", new Double( max ) );
        info.flush();
    }
    public double getMaximumSize() { return max; }
    
    public void setMinimumSize( double s ) { 
        min = s; 
        info.put( "RDSettings.min", new Double( min ) );
        info.flush();
    }
    public double getMinimumSize() { return min; }
    
    public void setPeakCutoff( float s ) {
        peakValue = s; 
        info.put( "RDSettings.peak", new Double( peakValue) );
        info.flush();
    }
    public float getPeakCutoff() { return peakValue; }
}

