package molmaster.gui.editbar.analysis;

import molmaster.util.*;

/** Accessor functions to allow for editing of
 *  the various ring search attributes.
 *
 * @author  Russell Power
 */
public class RingSettings {
    private DataStore info = new DataStore("appSettings");
    private int max = 6;
    private double maxBond = 5.0;
    
    public RingSettings() {
        Integer i = (Integer)info.get( "RingSettings.max" );
        if ( i != null ) { max = i.intValue(); }
        Double d = (Double)info.get("RingSettings.maxBond" );
        if ( d != null ) { maxBond = d.doubleValue(); }
    }
    
    public int getMaximumRingSize() { return max; }
    public void setMaximumRingSize(int in) {
        max = in;
        info.put( "RingSettings.max", new Integer( in ) );
        info.flush();
    }
    
    public double getMaximumBondSize() { return maxBond; }
    public void setMaximumBondSize(double in) {
        maxBond = in;
        info.put( "RingSettings.maxBond", new Double( in ) );
        info.flush();
    }
}
