package molmaster.gui.help;

import javax.swing.*;
import java.util.*;
import java.awt.*;


/**
 *
 * @author  Russell Power
 */
public class AboutDialog extends javax.swing.JDialog {

	/** Creates new form AboutDialog */
	public AboutDialog(java.awt.Frame parent, boolean modal) {
		super(parent, modal);
		initComponents();
		Map m = javax.media.j3d.VirtualUniverse.getProperties();
		String s = "Java3D Version: " + m.get("j3d.version");
		java3dver.setText(s);
	}

	private void initComponents() { //GEN-BEGIN:initComponents
		final RenderingHints rh =
			new RenderingHints(
				RenderingHints.KEY_ANTIALIASING,
				RenderingHints.VALUE_ANTIALIAS_ON);
		jLabel1 = new javax.swing.JLabel() {
			public void paint(Graphics g) {
				((Graphics2D) g).setRenderingHints(rh);
				super.paint(g);
			}
		};
		java3dver = new JLabel("Java3d Version: ") {
			public void paint(Graphics g) {
				((Graphics2D) g).setRenderingHints(rh);
				super.paint(g);
			}
		};
		btnOkay = new javax.swing.JButton();
		background = new javax.swing.JLabel();

		getContentPane().setLayout(null);

		setTitle("About molMaster");
		setResizable(false);
		addWindowListener(new java.awt.event.WindowAdapter() {
			public void windowClosing(java.awt.event.WindowEvent evt) {
				closeDialog(evt);
			}
		});

		jLabel1.setText("Author: Russell Power");
		getContentPane().add(jLabel1);
		jLabel1.setBounds(190, 120, 140, 30);

		java3dver.setText("Java3d Version:");
		getContentPane().add(java3dver);
		java3dver.setBounds(190, 150, 200, 16);

		btnOkay.setText("Okay");
		btnOkay.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(java.awt.event.ActionEvent evt) {
				btnOkayActionPerformed(evt);
			}
		});

		getContentPane().add(btnOkay);
		btnOkay.setBounds(50, 180, 61, 25);

		background.setIcon(
			new javax.swing.ImageIcon(
				getClass().getResource("/graphics/about.png")));
		getContentPane().add(background);
		background.setBounds(0, 0, 430, 280);

		pack();
		java.awt.Dimension screenSize =
			java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		setSize(new java.awt.Dimension(399, 241));
		setLocation(
			(screenSize.width - 399) / 2,
			(screenSize.height - 241) / 2);
	} //GEN-END:initComponents

	private void btnOkayActionPerformed(
		java.awt.event.ActionEvent evt) {
		//GEN-FIRST:event_btnOkayActionPerformed
		setVisible(false);
		dispose();
	} //GEN-LAST:event_btnOkayActionPerformed

	/** Closes the dialog */
	private void closeDialog(
		java.awt.event.WindowEvent evt) { //GEN-FIRST:event_closeDialog
		setVisible(false);
		dispose();
	} //GEN-LAST:event_closeDialog

	/**
	 * @param args the command line arguments
	 */
	public static void main(String args[]) {
		new AboutDialog(new javax.swing.JFrame(), true).show();
	}

	// Variables declaration - do not modify//GEN-BEGIN:variables
	private javax.swing.JLabel background;
	private javax.swing.JButton btnOkay;
	private javax.swing.JLabel java3dver;
	private javax.swing.JLabel jLabel1;
	// End of variables declaration//GEN-END:variables

}
