package molmaster.gui.help;

import java.awt.event.*;
import java.net.*;
import java.util.*;
import javax.swing.event.*;

/** Renders molmaster help pages...
 *
 * @author  Russell Power
 */
public class HelpDialog extends javax.swing.JDialog implements javax.swing.event.HyperlinkListener {
    
    private List history = new ArrayList();
    
    /** Creates new form HelpDialog */
    public HelpDialog(java.awt.Frame parent, boolean modal) {
        super(parent, modal);
        initComponents();
        try {
            browser.setPage( new URL( "http", "bestla.chem.washington.edu", "/~molmaster/help/index.php" ) );
            browser.addHyperlinkListener( this );
        }catch(Exception e){
            e.printStackTrace();
        }
        
    }
    
    private void initComponents() {//GEN-BEGIN:initComponents
        toolbar = new javax.swing.JToolBar();
        btnBack = new javax.swing.JButton();
        btnClose = new javax.swing.JButton();
        lnkLabel = new javax.swing.JLabel();
        browserScroll = new javax.swing.JScrollPane();
        browser = new javax.swing.JEditorPane();

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        toolbar.setDoubleBuffered(true);
        btnBack.setText("Back");
        btnBack.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnBackActionPerformed(evt);
            }
        });

        toolbar.add(btnBack);

        btnClose.setText("Close");
        btnClose.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btnCloseActionPerformed(evt);
            }
        });

        toolbar.add(btnClose);

        lnkLabel.setFont(new java.awt.Font("Dialog", 0, 12));
        lnkLabel.setText("Note: This info is online at: http://molmaster.sourceforge.net/help");
        toolbar.add(lnkLabel);

        getContentPane().add(toolbar, java.awt.BorderLayout.NORTH);

        browser.setEditable(false);
        browserScroll.setViewportView(browser);

        getContentPane().add(browserScroll, java.awt.BorderLayout.CENTER);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(602, 464));
        setLocation((screenSize.width-602)/2,(screenSize.height-464)/2);
    }//GEN-END:initComponents

    private void btnCloseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnCloseActionPerformed
        setVisible( false );
        dispose();
    }//GEN-LAST:event_btnCloseActionPerformed

    private void btnBackActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btnBackActionPerformed
        if ( history.isEmpty() ) { getToolkit().beep(); }
        try {
            URL u = (URL)history.remove( history.size() - 1 );
            browser.setPage( u );
        }catch(Exception e){}
    }//GEN-LAST:event_btnBackActionPerformed
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    /**
     * @param args the command line arguments
     */
    public static void main(String args[]) {
        HelpDialog hd = new HelpDialog(new javax.swing.JFrame(), true);
        hd.addWindowListener( 
        new WindowAdapter() {
            public void windowClosed( WindowEvent e ) { System.exit(0); }
        });
        hd.show();
    }
    
    public void hyperlinkUpdate(javax.swing.event.HyperlinkEvent evt) {
        if ( !(evt.getEventType() == HyperlinkEvent.EventType.ACTIVATED) ) { return; }
        try {
            history.add( browser.getPage() );
            String s = evt.getURL().toExternalForm();
            String out = "";
            int last = 0;
            while ( s.indexOf(' ', last) != -1 ) {
                out += s.substring( last, s.indexOf( ' ', last ));
                out += "%20";
                last = s.indexOf( ' ', last ) + 1;
            }
            out += s.substring( last );
            //stem.out.println("Loading: " + evt.getURL().toExternalForm() );
            browser.setPage( out );
        }catch(Exception e){
            System.out.println("Couldn't load page:" + e );
        }
    }    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btnClose;
    private javax.swing.JButton btnBack;
    private javax.swing.JToolBar toolbar;
    private javax.swing.JScrollPane browserScroll;
    private javax.swing.JLabel lnkLabel;
    private javax.swing.JEditorPane browser;
    // End of variables declaration//GEN-END:variables
    
}
