package molmaster.gui.input;
import molmaster.*;
import javax.media.j3d.*;
import javax.vecmath.*;

import java.util.*;

import molmaster.*;
import molmaster.gui.*;

/** Generates a cylinder connecting two points in space. */
public class AttachPoints{
    
    //  TODO - WEAK?
    static public Map bondMap = new HashMap();
    
    /** Creates a BondView representing the given input Bond and Atoms, and connecting
     * the 6 points listed.  The bond is then attached to the given input group.
     */    
    static public void attach(
    Group group, Atom start, Atom end, Bond bondIn){
        
        TransformGroup tg = new TransformGroup();
        
        //tg.setTransform(getTransform(x1,x2,y1,y2,z1,z2));
        
        tg.setTransform( getTransform( start.getLocation(), end.getLocation() ) );
        
        tg.setCapability( TransformGroup.ALLOW_TRANSFORM_READ );
        tg.setCapability( TransformGroup.ALLOW_TRANSFORM_WRITE );
        
        tg.clearCapabilityIsFrequent( TransformGroup.ALLOW_TRANSFORM_READ );
        tg.clearCapabilityIsFrequent( TransformGroup.ALLOW_TRANSFORM_WRITE );
        if ( bondIn == null ) {
            bondIn = new Bond( start, end, Bond.BOND_TYPE_NORMAL);
        }
        BondView cylinder = new BondView(bondIn, tg);
        
        //tg.addChild(cylinder);
        BranchGroup g = new BranchGroup();
        g.setCapability( BranchGroup.ALLOW_DETACH );
        g.addChild(tg);
        group.addChild(g);
        
        bondMap.put( cylinder, g );
    }
    
    public static final Transform3D getTransform( Tuple3d start, Tuple3d end ) {
        Vector3d mid = new Vector3d();
        mid.add( start );
        mid.add( end );
        mid.scale( 0.5 );
        
        Vector3d unit = new Vector3d();
        unit.sub( end, start );
        unit.normalize();
        
        Vector3d rot = new Vector3d();
        Vector3d y = new Vector3d( 0, 1, 0);
        rot.cross( y, unit );
        
        Quat4d rotQ = new Quat4d( rot.x, rot.y, rot.z, y.dot( unit ) );
        rotQ.set( new AxisAngle4d( rot.x, rot.y, rot.z, Math.acos( unit.dot( y) ) ) );
        return new Transform3D ( rotQ, mid, 1.0 );
    }
}

/*
 * Returns a Transform3D that can be used to create a cylinder connecting the
     * 2 input points.
     
    static public Transform3D getTransform( 
    double x1, double x2, double y1, 
    double y2, double z1, double z2 ){
        Transform3D transform = new Transform3D();
        
        //Work out center...
        double cx = (x1+x2) / 2;
        double cy = (y1+y2) / 2;
        double cz = (z1+z2) / 2;
        Vector3d vector = new Vector3d(cx, cy, cz);
        transform.setTranslation(vector);
        
        //Work out the length
        double dx = (double) (x2-x1);
        double dy = (double) (y2-y1);
        double dz = (double) (z2-z1);
        float s = (float) Math.sqrt(dx*dx + dy*dy + dz*dz);
        
        //Work out rotation on Z-axis...
        double rotZ=0;
        if (dx==0){
            rotZ=0;
        }else if (dy==0){
            //CHANGE THIS...
            rotZ=Math.PI/2;//if this is negative, remove the -rotX below
            if (dx<0){
                rotZ = -rotZ;
            }
        }else if (dx!=0){
            rotZ=-Math.atan(Math.abs(dx)/Math.abs(dy));
            if (dy<0){
                if (dx>0){
                    rotZ = Math.PI+rotZ;
                }else{
                    rotZ = Math.PI*3-rotZ;
                }
            }else{
                if (dx>0){
                    rotZ=-rotZ;
                }
            }
        }
        rotZ=-rotZ;
        double degrees = rotZ * (180d/Math.PI);
        
        //Work out rotation on X axis...
        double rotX = Math.atan( Math.abs(z2-cz) / (0.5*Math.sqrt(dx*dx+dy*dy)) );
        rotX=-rotX;//If this goes, alter the CHANGE THIS above
        if (z2-cz>0){
            //CHANGE THIS...
            rotX = -rotX;
        }
        //rotX=Math.PI-rotX;
        degrees = rotX * (180d/Math.PI);
        //rotX=0;
        
        Transform3D rotationZ = new Transform3D();
        Transform3D rotationX = new Transform3D();
        rotationZ.rotZ(rotZ);
        rotationX.rotX(rotX);
        
        transform.mul(rotationZ);
        transform.mul(rotationX);
        
        return transform;
    }

*/