package molmaster.gui.input;

/** Classes implementing this interface are 
 *  eligible to add themselves to the MouseHandler
 *  and receive mouse events.
 *
 * @author  rjpower
 */
public interface IMouseMethod {
    /** Called by the mouse handler when a mouse
     *  event has occurred. */
    public void processEvent( int x, int y, java.awt.event.MouseEvent e );  
    
     /** Reset any selections currently in progress,
     *  and return to default state.
     */
    public void clear();
}
