package molmaster.gui.input;


import javax.vecmath.*;
import java.awt.event.*;
import javax.media.j3d.*;

/** A simple class to detect keystrokes and signal
 *  a listener when they occur.  Useful for providing
 *  canceling functionality, or deleting objects...
 *
 * @author  Russell
 */

public class KeyWakeupBehavior extends Behavior {
 
    Listener listener;
    WakeupOnAWTEvent keyWake = new WakeupOnAWTEvent( java.awt.event.KeyEvent.KEY_PRESSED );
    java.util.Set wakeKeys = new java.util.HashSet();
    
    public KeyWakeupBehavior( Listener m ){
        listener = m;
        setSchedulingBounds( new BoundingSphere( new Point3d(), Double.POSITIVE_INFINITY ) );
    }
    
    public void initialize() {
        this.wakeupOn( keyWake );
    }
    
    public void addKeyCode( int keyCode ) {
        wakeKeys.add( new Integer(keyCode) );
    }
    
    public void processStimulus(java.util.Enumeration enumeration) {
                
        if ( !keyWake.hasTriggered() ) {
            wakeupOn( keyWake );
            return;
        }
        
        java.awt.AWTEvent[] events = keyWake.getAWTEvent();
        
        for ( int i = 0; i < events.length; i++ ) {
            
            if ( !KeyEvent.class.isInstance(events[i]) )
                continue;
            
            KeyEvent e = (KeyEvent)events[i];
            if ( wakeKeys.contains( new Integer(e.getKeyCode()) ) ) {
                listener.wakeup( e.getKeyCode() );
            }
        }
        
        wakeupOn( keyWake );
    }
    
}
