package molmaster.gui.input;

import java.awt.event.MouseEvent;

import javax.media.j3d.*;

import molmaster.*;
import molmaster.gui.*;
import molmaster.gui.editbar.*;

/**
 *
 * @author  rjpower
 */
public class MouseDrag extends MouseMethod implements IMouseMethod {

	/** Creates a new instance of MouseDrag */
	public MouseDrag(Canvas3D canvas, BranchGroup root, MolUniverse uni) {
		super(canvas, root, uni);
	}

	/** Reset any selections currently in progress,
	 * and return to default state.
	 */
	public void clear() {
	}

	/** Called by the mouse handler when a mouse
	 * event has occurred.  */
	public void processEvent(int x, int y, java.awt.event.MouseEvent e) {
		if (e.getID() == MouseEvent.MOUSE_PRESSED
			&& e.getID() != MouseEvent.MOUSE_DRAGGED) {
			ActiveAction.notifyHandler(this, new Event(mousePressed, e));
		} else if (e.getID() == MouseEvent.MOUSE_DRAGGED) {
			ActiveAction.notifyHandler(this, new Event(mouseDragged, e));
		} else if (e.getID() == MouseEvent.MOUSE_RELEASED) {
			ActiveAction.notifyHandler(this, new Event(mouseReleased, e));
		}

	}

}