package molmaster.gui.input;

import java.awt.event.MouseEvent;

import molmaster.*;
import molmaster.gui.*;

import javax.media.j3d.*;
import com.sun.j3d.utils.picking.*;

/** Performs actions associated with single
 *  or multiple click events on the canvas.  This
 *  includes at the moment selecting atoms and
 *  creating bonds between two atoms.
 *
 * @author  rjpower
 */
public class MouseSelect extends MouseMethod implements IMouseMethod, Listener {
    
    protected KeyWakeupBehavior deleteKey
    = new KeyWakeupBehavior( this );
    
    protected PickCanvas pickCanvas;
    
    public static EventID mouseSelect = new EventID( MouseSelect.class, "Mouse Selection" );
    
    /** Creates a new instance of MouseSelect */
    public MouseSelect(Canvas3D canvas, BranchGroup root, MolUniverse u) {
        super(canvas,root,u);
        this.root = root;
        uni = u;
        deleteKey.addKeyCode( java.awt.event.KeyEvent.VK_DELETE );
        root.addChild( deleteKey );
    }
    
    /** Called by the mouse handler when a mouse
     * event has occurred.  */
    public void processEvent(int x, int y, java.awt.event.MouseEvent e) {
        
        //  we only care about mouse clicks
        if ( e.getID() != MouseEvent.MOUSE_CLICKED && e.getID() != MouseEvent.MOUSE_PRESSED  ) {
            return;
        }
        
        if ( ( e.getModifiers() & MouseEvent.BUTTON1_MASK) == 0 ) { 
            return;
        }
        Node p = pickShape( x, y  );
        
        if ( p == null ) {
            return;
        }
        try {
            MolView shape = (MolView)p;
            if ( shape == null ) { return; }
            molmaster.gui.editbar.ActiveAction.notifyHandler( 
            this, new Event( mouseSelect, shape, e ) );
        }catch(Exception ex){}
        
    }

    public void wakeup( int keycode ){
        
    }
    public void clear() {}
}
