package molmaster.gui.toolbar;

import java.awt.*;

/** Implements a separator - divides off portions
 *  of the toolbar.
 *
 * @author  Russell Power
 */
public class Separator extends EditButton {
    
    private static final int thickness = 1;
    
    public Separator() { 
        super("Separator"); 
        setIcon(blankIcon); 
        setText("|                 "); 
        setBorderPainted( true );
        setBorder( javax.swing.BorderFactory.createLineBorder( java.awt.Color.black ) );
        setSize( getWidth() * 2, getHeight() );
    }

    public void paint( Graphics g  ) {
    	
    	g.setColor( defaultColor.get() );
    	g.fillRect( 0, 0, getWidth(), getHeight() );
    	
        g.setColor( java.awt.Color.darkGray );
        
        if ( isSmall() ){
            g.drawLine( getWidth() / 2, 0, getWidth()/2, getHeight() );
        }else {
            g.drawLine( blankIcon.getIconWidth() + 2, getHeight() / 2, getWidth()*2, getHeight() / 2);
        }
    }
}
