/*
 * ColorEditor.java
 *
 * Created on June 19, 2002, 3:33 PM
 */

package molmaster.gui.tools;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;


/**
 *
 * @author  Russell Power
 */

public class ColorEditor extends DefaultCellEditor {
    Color currentColor = null;
    Object currentVal = null;
    CellEditor delegate;
    ActionListener l = new ActionListener(){
        public void actionPerformed(ActionEvent e) {
            fireEditingStopped();
        }
    };
    
    ColorEditor(JButton b ){
        super( new JCheckBox() );
        setClickCountToStart(1);
        editorComponent = b;
        b.addActionListener( l );
    }
    protected void fireEditingStopped() {
        super.fireEditingStopped();
    }
    
    public Object getCellEditorValue() {
        if ( delegate != null ) {
            return delegate.getCellEditorValue();
        }
        return currentColor;
    }
    
    public java.awt.Component getTableCellEditorComponent(JTable table,
    Object value,
    boolean isSelected,
    int row,
    int col) {
        delegate = null;
        
        if ( value instanceof Boolean ) {
            JCheckBox b = new JCheckBox();
            b.addActionListener( l );
            DefaultCellEditor edit = new DefaultCellEditor(b  );
            delegate = edit;
            return edit.getTableCellEditorComponent( table, value, isSelected, row, col );
        }
        else if( !(value instanceof Color) ) {
            JTextField f = new JTextField();
            f.addActionListener( l );
            DefaultCellEditor edit = new DefaultCellEditor(f);
            delegate = edit;
            return edit.getTableCellEditorComponent( table, value, isSelected, row, col );
        }
        
        currentColor = (Color)value;
        return editorComponent;
    }
}