package molmaster.gui.tools;

/** Encapsulates the various tool panels used for
 *  manipulating values from within molmaster.
 *
 * @author  rjpower
 */
public class ToolFrame extends javax.swing.JDialog {
    
    /** Contains the tool panels used by molmaster.  At the current time these are:
     *
     * Lights
     * Files
     * Bonds
     * Movie
     * View
     *
     * One tool panel exists throughout the entire execution of molmaster.
     */    
    static public ToolFrame toolFrame;
    
    /** Creates new form ToolFrame */
    public ToolFrame() {
        super( molmaster.gui.MainFrame.getActiveWindow(), false );
        initComponents();
        toolPane.add("Lights", new LightPanel() );
        toolPane.add("Files", new FilePanel() );
        toolPane.add("Bonds", new BondPanel() );
        toolPane.add("Movies", new AnimationPanel() );
        toolPane.add("View", new ViewPanel() );
        setLocation( 500, 0 );
        setSize( 300, 400 );
        toolFrame = this;
        //this.setIgnoreRepaint( true );
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        toolPane = new javax.swing.JTabbedPane();

        setTitle("tools");
        getContentPane().add(toolPane, java.awt.BorderLayout.CENTER);

        pack();
    }//GEN-END:initComponents

    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTabbedPane toolPane;
    // End of variables declaration//GEN-END:variables
    
}
