package molmaster.gui.tools.reflect;

import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.vecmath.*;

/**
 *
 * @author  Russell Power
 */
public class ColorEditor implements PopupEditor {
    
    protected MethodValue m;
    protected JDialog jc;
    protected JColorChooser colorChoose;
    
    protected Object outColor;
    /** Creates a new instance of ColorEditor */
    public ColorEditor() {
    }
    
    public javax.swing.JDialog getPopup(MethodValue mv) {
        m = mv;
        Object o = m.get();
        Color c = null;
        if ( o instanceof Color ) {
            outColor = (Color)m.get();
            c = (Color)outColor;
        }else{
            outColor = (javax.vecmath.Color3f)m.get();
            c = ((Color3f)m.get()).get();
        }
        
        colorChoose = new JColorChooser( c );
        jc = JColorChooser.createDialog( 
            new JComponent(){}, 
            "Select color", 
            true, 
            colorChoose,
            new ActionListener() { 
                public void actionPerformed(ActionEvent e) {
                    outColor = colorChoose.getColor(); 
                }
            },
            new ActionListener() {
                public void actionPerformed(ActionEvent e) {}
            }
        );
        return jc;
    }
    
    /** Returns a list of types that this editor supports. */    
    public Class[] getSupportedTypes() {
        return new Class[] { Color.class, javax.vecmath.Color3f.class };
    }
    
    public Object getValue() {
        if ( m.ownerType == javax.vecmath.Color3f.class ) {
            if ( outColor instanceof Color ) {
                return new Color3f( (Color)outColor );
            }else { return (Color3f)outColor; }
        }
        else {
            if ( outColor instanceof Color ) { return (Color)outColor; }
            else { 
                Color3f c = (Color3f)outColor;
                return c.get();
            }
        }
    }
    
}
