/*
 * FileRenderer.java
 *
 * Created on June 12, 2002, 5:09 PM
 */

package molmaster.gui.tools.reflect;
import java.awt.*;
import java.awt.event.*;

import java.io.*;

import javax.swing.*;

/** Implements a filename editor / dialog.
 *
 * @author  Russell Power
 */
public class FileRenderer extends ReflectComponent{
    
    static protected File lastVal;
    static protected ActionListener listen;
    
    /** Creates a new instance of FileRenderer */
    public FileRenderer() {
    }
    
    public Object getValue() {
        return lastVal;
    }
    
    static public void setVal( File f ) {
        lastVal = f; 
        listen.actionPerformed( new ActionEvent( lastVal, 10, "stuff" ) );
    }
    
    public void setValue(Object orig, ActionListener l ) throws ClassCastException {
        lastVal = (File)orig;
        listen = l;
        
        JPanel pnl = new JPanel();
        JButton selector = new FileButton( (File)orig );
        
        JTextField txt = new FileTextField( (File)orig );
        txt.setBorder( null );
        
        pnl.setLayout( new java.awt.BorderLayout() );
        pnl.add( txt, BorderLayout.CENTER );
        pnl.add( selector, BorderLayout.EAST );
        
        comp = pnl;
        comp.setBorder( null );
    }
}

class FileButton extends JButton implements ActionListener {
    File myFile;
    
    FileButton(File f) {
        super("...");
        myFile = f;
        addActionListener( this );
    }
    
    public void actionPerformed(java.awt.event.ActionEvent evt) {
        JFileChooser chooser = new JFileChooser( myFile.getParent() );
        chooser.setMultiSelectionEnabled( false );
        chooser.setFileSelectionMode( JFileChooser.FILES_AND_DIRECTORIES );
        chooser.showOpenDialog( molmaster.gui.MainFrame.getActiveWindow() );
        
        File f = chooser.getSelectedFile();
        if ( f == null ) { return; }
        FileRenderer.setVal ( f );
    }
    
}
class FileTextField extends JTextField implements ActionListener {
    File myFile;
    
    FileTextField( File f )  {
        super( f.toString() );
        myFile = f;
        addActionListener( this );
    }
    
    public void actionPerformed(java.awt.event.ActionEvent evt) {
        File f = new File( getText() );
        FileRenderer.setVal ( f );
    }
    
}