package molmaster.gui.tools.reflect;

import java.awt.event.*;

/** Abstract base class for visual representations
 *  of reflected class types.  Subclasses should
 *  implements the set and getValue methods, and
 *  set the <code>comp</code> object to be the 
 *  component to be displayed.
 *
 * @author  Russell
 */
public abstract class ReflectComponent implements ReflectEditor {
    
    protected javax.swing.JComponent comp;
    
    public abstract void setValue( Object val, ActionListener l ) throws ClassCastException;
    public javax.swing.JComponent getComponent(){
        return comp;
    }
    
    public abstract Object getValue();
    
}
