package molmaster.gui.tools.reflect;

/** Displays an editable reflected copy of an
 *  objects contents in a JDialog.  This dialog
 *  simply encapsulates a ReflectTable for 
 *  convenient usage.
 *
 * @author  Russell Power
 */
public class ReflectDialog extends javax.swing.JDialog {
    
    private Object source;
    
    public ReflectDialog(java.awt.Frame parent, Object source, boolean modal) {
        super(parent, modal);
        this.source = source;
        initComponents();
        setTitle( "Settings" );
    }
    
    public ReflectDialog(java.awt.Dialog parent, Object source, boolean modal) {
        super(parent,modal);
        this.source =source;
        initComponents();
        setTitle( "Settings" );
    }

    private void initComponents() {//GEN-BEGIN:initComponents
        jScrollPane1 = new javax.swing.JScrollPane();
        jTable1 = new ReflectTable( source );

        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                closeDialog(evt);
            }
        });

        jScrollPane1.setViewportView(jTable1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
        java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
        setSize(new java.awt.Dimension(384, 291));
        setLocation((screenSize.width-384)/2,(screenSize.height-291)/2);
    }//GEN-END:initComponents
    
    /** Closes the dialog */
    private void closeDialog(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_closeDialog
        setVisible(false);
        dispose();
    }//GEN-LAST:event_closeDialog
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTable jTable1;
    // End of variables declaration//GEN-END:variables
    
}
