package molmaster.model;

/**
 *
 * @author  Russell
 */
public class DefaultWatchedObject implements WatchedObject {
    
    protected java.util.Set listeners = new java.util.HashSet();
    
    public DefaultWatchedObject() {}
    
    /** Adds a listener to this object.  When events occur, the list of listeners
     * will be traversed and each listener will be notified of the event.
     */    
    public void addListener(Listener l) {
        listeners.add(l);
    }
    
    /** Removes the given object from the notification list.
     */    
    public void removeListener(Listener l) {
        listeners.remove(l);
    }
    
    /** Signals all listeners to the given event.
     */    
    public void signal( WatchedObject signaler, int signalType, Object data ) {
        java.util.Iterator i = listeners.iterator();
        while ( i.hasNext() ) {
            ((Listener)i.next()).wakeUp( signaler, signalType, data );
        }
    }
}
