/*
 * ModelListener.java
 *
 * Created on March 9, 2002, 1:19 PM
 */

package molmaster.model;

/** Implemented by all objects that need to listen
 *  for changes to the model.
 * @author  Russell
 */
public interface ModelListener {
    
    public static final int ATOM_REMOVED =  0x0001;
    public static final int ATOM_ADDED =    0x0002;
    
    public static final int BOND_ADDED =    0x0004;
    public static final int BOND_REMOVED =  0x0008;
    public static final int BOND_GROUP_ADDED = 0x0010;
    
    public static final int FILE_ADDED  =   0x0020;
    public static final int FILE_REMOVED =  0x0040;
    
    //  generic update command
    public static final int MODEL_UPDATE =  0x8000;

    /** Called in response to a change in the state of the model.  The event type can
     * be any of the defined constants in ModelListener.
     * @param opType The type of event that has occured.
     * @param opValue A handle to the object that has been added or removed from the model.
     */    
    public void modelUpdated( MolModel scene, int opType, Object opValue);
}
