package molmaster.model;

/**
 *
 * @author  Russell
 */
public interface WatchedObject {
   
    static public final int CREATED     = 0x0001;
    static public final int DESTROYED   = 0x0002;
    static public final int SELECTED    = 0x0004;
    static public final int MOVED       = 0x0008;
    static public final int CONNECTED   = 0x0010;
    static public final int DISCONNECTED= 0x0020;
    static public final int UNSELECTED  = 0x0040;
    
    /** Adds a listener to the notification list for this object.  When an event occurs
     * all listeners will be notified.
     */    
    public void addListener ( Listener l );
    /** Removes the given listener from the notification list of this object.
     */    
    public void removeListener( Listener l );
    
}
