/*
 * FieldFile.java
 *
 * Created on June 4, 2002, 12:45 PM
 */

package molmaster.model.loaders;

/** Describes the interface required of loaders to
 *  represent a field file to the rest of the program.
 *
 * @author  rjpower
 */
public interface FieldFile {
    
    /** Returns a 3d array representing the field values
     *  at points in space.  Each index position is multiplied
     *  by the basis vector to obtain the field location in space.  */
    public double[][][] getField();
    
    /** Returns the basis vectors used to obtain field locations.   */
    public javax.vecmath.Vector3d[] getBasis();
    
    /** Returns the minimum field value taken on by this field. */
    public double getFieldMin();
    
    /** Maximum value taken by this field.    */
    public double getFieldMax();
    
}
