package molmaster.model.loaders;

/** Interface for loading movies in molmaster.  These are 
 *  represented as a series of frames which are queried for
 *  by the movie framework when needed.
 *
 * @author  rjpower
 */
public interface MovieFile {
    
    /** Return all atoms in the given 0 based frame index.  */
    public java.util.List getAtomFrame( int frame );
    
    /** Return all bonds in the given 0 based frame index.  */
    public java.util.List getBondFrame( int frame );
    
    /** Return the number of frames in this file.   */
    public int getFrameCount();
}
