package molmaster.util;

import com.sun.j3d.utils.geometry.*;
import javax.media.j3d.*;
import javax.vecmath.*;

/** Generates a cone representing an arrow between
 *  the two given points.
 */
public class Arrow {
    
  //Creates an 3Darrow between point stPt and endPt
  public static TransformGroup createArrow(float diameter, Vector3d start, Vector3d end)
  {
        Vector3d unit = new Vector3d();
        unit.sub( end, start );
        unit.normalize();
        
        Vector3d rot = new Vector3d();
        Vector3d y = new Vector3d( 0, 1, 0);
        rot.cross( y, unit );
        
        Vector3d dist = new Vector3d();
        dist.sub( end, start );
        
        Quat4d rotQ = new Quat4d( rot.x, rot.y, rot.z, y.dot( unit ) );
        rotQ.set( new AxisAngle4d( rot.x, rot.y, rot.z, Math.acos( unit.dot( y) ) ) );
        Transform3D trans = new Transform3D ( rotQ, start, 1.0 );
        trans.setScale( new Vector3d( 1, dist.length(), 1 ) );
        
        TransformGroup tg = new TransformGroup();
        tg.setTransform( trans );
        tg.addChild( new Cone( diameter, 1.0f ) );
        
        return tg;
  }
}
