package molmaster.util;

/**
 * @author Russell Power
 *	
 * Implements a simple thread interface to allow for
 * a callback to another Runnable interface when the
 * given thread finishes execution.
 * 
 */
public class CallbackThread extends Thread {

	private Runnable start;
	private Runnable callback;
	
    /** Creates a new CallbackThread that will run the initial process and second
     * process in sequence.
     */    
	public CallbackThread( Runnable start, Runnable callback ) {
		super();
		this.start = start;
		this.callback = callback;		
	}
	
	public void run() {
		start.run();
		callback.run();
	}
}
