package molmaster.util;

import java.io.*;
import java.util.*;
import javax.swing.*;

/** Convenience methods for loading text strings from
 *  a property file.
 *
 * @author  rjpower
 */
public class GetText {
    
    static private final Map stringMap = new HashMap();
    static {
        try {
            FileReader fr = new FileReader( "lib/lang.txt" );
            BufferedReader buf = new BufferedReader( fr );
            
            String line = null;
            String message = "";
            String title = null;
            
            while ( ( line = buf.readLine() ) != null ) {
                if ( line.startsWith("~") ) {
                    if ( title != null ) {
                        stringMap.put( title,  message );
                    }
                    title = line.substring( 1 );
                    message = "";
                }
                else {
                    if ( line != null ) {
                        message += line + "\n";
                    }
                }
            }
            
            stringMap.put( title,  message );
        }catch(Exception e ){
            
        }
    }
    
    /** Returns a text passage for the given key string.
     */    
    static public String get( String id ) {
        return (String)stringMap.get( id );
    }
    
    /** Shows a help dialog with the main application frame as it's parent and the
     * text found for the given key string as the message.
     */    
    static public void showHelpDialog( String id ) {
         showHelpDialog( molmaster.gui.MainFrame.getActiveWindow(), id );
    }
    static public void showHelpDialog( JDialog parent, String id ) {
        String s = get( id );
        JOptionPane.showMessageDialog( parent, s, "Help Message", JOptionPane.INFORMATION_MESSAGE );
    }
 
    static public void showHelpDialog( JFrame parent, String id ) {
        String s = get( id );
        JOptionPane.showMessageDialog( parent, s, "Help Message", JOptionPane.INFORMATION_MESSAGE );
    }
}
