package molmaster.util;

import image.codec.PNGImageEncoder;

import java.io.*;
import molmaster.gui.*;

/** Provides a simple way to capture images to a file.  
 *
 *
 *
 */
public class ImageCapture implements CapturedImageObserver {
    File dest;
    /** Creates a new ImageCapture which will write out results to the given file.
     */    
    public ImageCapture( File dest ) {
        String s = dest.getAbsolutePath();
        if ( !s.endsWith( ".png" ) ) {
            dest = new File( s + ".png" );
        }
        this.dest = dest;
        MainFrame.canvas.addCaptureObserver( this );
    }
    
    /** Called when the canvas has a picture ready to save.
     */    
    public boolean canvasImageCaptured(java.awt.image.BufferedImage img) {
        try {
            FileOutputStream fout = new FileOutputStream( dest );
            BufferedOutputStream bout = new BufferedOutputStream( fout );
			PNGImageEncoder pg = new PNGImageEncoder(bout, null);
            pg.encode(img);
            bout.close();
            fout.close();
        }catch(Exception e){
            javax.swing.JOptionPane.showMessageDialog(
            MainFrame.getActiveWindow(),
            "Couldn't save image... error follows\n\n" + e,
            "Error saving image",
            javax.swing.JOptionPane.ERROR_MESSAGE );
        }
		MainFrame.canvas.removeCaptureObserver(this);
        MainFrame.setProgressMeter(0);
        MainFrame.setStatusMessage( "Done saving image." );
        notifyAll();
        return false;
    }
}